unit RTFViaJIT;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ppClass,  ppBands, ppCache, ppCtrls, ppComm, ppReport,
  ppPrnabl, ppDB, ppDBBDE, Db, DBTables, ppStrtch, ppMemo, ppTypes,
  ppProd, ppDBJIT, ppVar, ppRelatv, ExtCtrls, ppGIF, ppRichTx, ComCtrls;

type
  Tfrm0136 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ppJITPipeline1: TppJITPipeline;
    ppReport2: TppReport;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    Button1: TButton;
    RichTx: TppField;
    ppDBRichText1: TppDBRichText;
    RichEdit1: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    function ppJITPipeline1GetFieldAsString(aFieldName: String): String;
  private
    function GetRichEdAsString(aRichEd: TRichEdit): String;

  public
    { Public declarations }
  end;

var
  frm0136: Tfrm0136;

implementation

{$R *.DFM}

uses
  GIFImage;

procedure Tfrm0136.FormCreate(Sender: TObject);
begin

  ppJITPipeline1.RecordCount := 1;

end;

procedure Tfrm0136.Button1Click(Sender: TObject);
begin
  RichEdit1.Lines.LoadFromFile('C:\My.rtf');

  ppReport2.Print;
end;

function Tfrm0136.ppJITPipeline1GetFieldAsString(aFieldName: String): String;
var
  lLines: TStrings;
begin

  if (aFieldName = 'RichTx') then
    Result := GetRichEdAsString(RichEdit1);

end;

function Tfrm0136.GetRichEdAsString(aRichEd: TRichEdit): String;
var
  lBuf: PChar;
  lRTFStream: TMemoryStream;

begin

  {create temp memory stream}
  lRTFStream := TMemoryStream.Create;

  {save the TRichEd's rtf data to the memory stream}
  aRichEd.Lines.SaveToStream(lRTFStream);

  {allocate memory for the pchar buffer ( size of stream + 1 for the null terminator}
  lBuf := StrAlloc(lRTFStream.Size + 1);

  {copy the rtf stream to the buffer}
  lRTFStream.Position := 0;
  lRTFStream.Read(lBuf^, lRTFStream.Size);

  {add a null terminator}
  lBuf[lRTFStream.Size] := #0;

  {copy to a delphi string}
  Result := String(lBuf);


  {free the buffer memory}
  StrDispose(lBuf);

  {free the memory stream}
  lRTFStream.Free;

end;

end.
